; Mode ####################################################################

    IFNDEF model
    model TEXTEQU <tiny>
    ENDIF
    .MODEL model

    option casemap :none   ; case sensitive
    option proc:private
    option language:c

; Inclde ##################################################################

    .386
    INCLUDE     ac16.inc

; Data Section ############################################################

    .DATA

    rand_seed   dw  0

; Code Section ############################################################

    .CODE

; =========================================================================
memcpy  proc CodePTR USES si di cx, target:DataPTR BYTE, source:DataPTR BYTE, count:WORD

    Model_Entry

    LoadPtr si, source
    LoadPtr di, target
    mov     cx, count
    rep     movsb

    Model_Leave
    
memcpy  endp
; =========================================================================
memset  proc CodePTR USES cx di, target:DataPTR BYTE, value:BYTE, count:WORD

    Model_Entry

    mov     cx, count
    LoadPtr di, target
    mov     al, value
    rep     stosb

    Model_Leave

memset  endp
; =========================================================================
printc  proc CodePTR USES dx, char:BYTE

    Model_Entry

    mov     ah, 02h
    mov     dl, char
    int     21h

    Model_Leave

printc  endp
; =========================================================================
prints  proc CodePTR USES si, string:DataPTR BYTE

    Model_Entry

    LoadPtr si, string
prints_1:
    lodsb
    or      al, al
    jz      prints_2
    invoke  printc, al
    jmp     prints_1
prints_2:
    Model_Leave

prints  endp
; =========================================================================
print1d proc CodePTR USES bx cx dx, value:BYTE

    Model_Entry

    xor     ax, ax
    mov     al, value

    .IF (al & 80h)
        neg     al
        push    ax
        invoke  printc, '-'
        pop     ax
    .ENDIF

    mov     bx, 10
    xor     cx, cx

    .WHILE (ax)
        xor     dx, dx
        div     bx
        push    dx
        inc     cx
    .ENDW

print1d_1:
    pop     ax
    add     al, 30h
    invoke  printc, al
    loop    print1d_1

    Model_Leave

print1d endp
; =========================================================================
print1u proc CodePTR USES bx cx dx, value:BYTE

    Model_Entry

    xor     ax, ax
    mov     al, value
    mov     bx, 10
    xor     cx, cx

    .WHILE (ax)
        xor     dx, dx
        div     bx
        push    dx
        inc     cx
    .ENDW

print1u_1:
    pop     ax
    add     al, 30h
    invoke  printc, al
    loop    print1u_1

    Model_Leave

print1u endp
; =========================================================================
print2d proc CodePTR USES bx cx dx, value:WORD

    Model_Entry

    mov     ax, value

    .IF (ax & 8000h)
        neg     ax
        push    ax
        invoke  printc, '-'
        pop     ax
    .ENDIF

    mov     bx, 10
    xor     cx, cx

    .WHILE (ax)
        xor     dx, dx
        div     bx
        push    dx
        inc     cx
    .ENDW

print2d_1:
    pop     ax
    add     al, 30h
    invoke  printc, al
    loop    print2d_1

    Model_Leave

print2d endp
; =========================================================================
print2u proc CodePTR USES bx cx dx, value:WORD

    Model_Entry

    mov     ax, value
    mov     bx, 10
    xor     cx, cx

    .WHILE (ax)
        xor     dx, dx
        div     bx
        push    dx
        inc     cx
    .ENDW

print2u_1:
    pop     ax
    add     al, 30h
    invoke  printc, al
    loop    print2u_1

    Model_Leave

print2u endp
; =========================================================================
print4d proc CodePTR USES ebx cx edx, value:DWORD

    Model_Entry

    mov     eax, value

    .IF (eax & 80000000h)
        neg     eax
        push    eax
        invoke  printc, '-'
        pop     eax
    .ENDIF

    mov     ebx, 10
    xor     cx, cx

    .WHILE (eax)
        xor     edx, edx
        div     ebx
        push    dx
        inc     cx
    .ENDW

print4d_1:
    pop     ax
    add     al, 30h
    invoke  printc, al
    loop    print4d_1

    Model_Leave

print4d endp
; =========================================================================
print4u proc CodePTR USES ebx cx edx, value:DWORD

    Model_Entry

    mov     eax, value
    mov     ebx, 10
    xor     cx, cx

    .WHILE (eax)
        xor     edx, edx
        div     ebx
        push    dx
        inc     cx
    .ENDW

print4u_1:
    pop     ax
    add     al, 30h
    invoke  printc, al
    loop    print4u_1

    Model_Leave

print4u endp
; =========================================================================
print1h proc CodePTR value:BYTE

    Model_Entry

    mov     al, value

    push    ax
    shr     al, 4
    .IF (al < 10)
        add     al, '0'
    .ELSE
        add     al, 'A'-10
    .ENDIF
    invoke  printc, al

    pop     ax
    and     al, 0fh
    .IF (al < 10)
        add     al, '0'
    .ELSE
        add     al, 'A'-10
    .ENDIF
    invoke  printc, al

    Model_Leave

print1h endp
; =========================================================================
print2h proc CodePTR value:WORD

    Model_Entry

    mov     ax, value
    push    ax
    invoke  print1h, ah
    pop     ax
    invoke  print1h, al

    Model_Leave

print2h endp
; =========================================================================
print4h proc CodePTR value:DWORD

    Model_Entry

    mov     eax, value
    push    eax
    shr     eax, 16
    invoke  print2h, ax
    pop     eax
    invoke  print2h, ax

    Model_Leave

print4h endp
; =========================================================================
printcr proc CodePTR 

    Model_Entry

    invoke  printc, 0dh
    invoke  printc, 0ah

    Model_Leave

printcr endp
; =========================================================================
strlen  proc CodePTR USES cx di, string:DataPTR BYTE

    Model_Entry

    LoadPtr di, string
    xor     cx, cx
    dec     cx
    xor     ax, ax
    repne   scasb
    not     cx
    dec     cx
    mov     ax, cx

    Model_Leave

strlen  endp
; =========================================================================
strcpy  proc CodePTR target:DataPTR BYTE, source:DataPTR BYTE

    Model_Entry

    invoke  strlen, source
    inc     ax
    invoke  memcpy, target, source, ax

    Model_Leave

strcpy  endp
; =========================================================================
strcat  proc CodePTR USES bx cx si di, target:DataPTR BYTE, source:DataPTR BYTE

    Model_Entry

    LoadPtr di, source
    xor     cx, cx
    xor     ax, ax
    dec     cx
    mov     dx, cx
    repne   scasb
    not     cx

    LoadPtr si, source
    LoadPtr di, target
    xchg    cx, dx
    repne   scasb
    dec     di
    mov     cx, dx

    rep     movsb

    Model_Leave

strcat  endp
; =========================================================================
srand   proc CodePTR 

    Model_Entry

    in      al, 40h
    shl     ax, 8
    in      al, 40h
    mov     rand_seed, ax        

    Model_Leave

srand   endp
; =========================================================================
rand    proc CodePTR USES bx

    Model_Entry

    mov     ax, rand_seed
    xchg    al, ah
    mov     bx, 190dh
    mul     bx
    add     ax, 10dch
    mov     rand_seed, ax

    Model_Leave

rand    endp
; =========================================================================
getch   proc CodePTR USES dx

    Model_Entry

    xor     ax, ax
    int     16h

    Model_Leave

getch   endp
; =========================================================================
exit    proc CodePTR exitcode:BYTE

    mov ah, 4ch
    mov al, exitcode
    int 21h

exit    endp
; =========================================================================

    END

