; #########################################################################
;
; Rockey4 Asm Sample For Masm 6.xx
; Please use mk.bat to build target file
; such as: mk small
;
; Note:
; rockey4.obj can support any mode(small...large)
; ac16.asm is asm simulator c language lib
;
; Mode ####################################################################

    IFNDEF model
    model TEXTEQU <tiny> 
    ENDIF
    .MODEL model, os_dos

    option casemap :none   ; case sensitive
    option proc:private
    option language:c

; Inclde ##################################################################

    .386
    INCLUDE     ac16.inc
    INCLUDE     rockey4.inc

    ShowERR PROTO rcode:WORD

; Data Section ############################################################

    .STACK

    .DATA
    handle  dw 16 dup(0)
    lp1     dd 0
    lp2     dd 0
    p1      dw 0c44ch
    p2      dw 0c8f8h
    p3      dw 00799h
    p4      dw 0c43bh
    buffer  db 1024 dup(0)
    retcode dw 0
    rc      dw 4 dup(0)
    cmd     db "H=H^H, A=A*23, F=B*17, A=A+F, A=A+G, A=A<C, A=A^D, B=B^B, C=C^C, D=D^D", 0
    cmd1    db "A=A+B, A=A+C, A=A+D, A=A+E, A=A+F, A=A+G, A=A+H", 0
    cmd2    db "A=E|E, B=F|F, C=G|G, D=H|H", 0

    info1   db "Hello"

; Code Section ############################################################

    .CODE
    .STARTUP

    xor     bx, bx
    invoke Rockey, RY_FIND, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
    .IF (ax != 0)
        invoke ShowERR, ax
        invoke exit, 0
    .ENDIF
    puts    "Find Rock: "
    invoke  print4h, lp1
    invoke  printcr

    invoke Rockey, RY_OPEN, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
    .IF (ax != 0)
        invoke ShowERR, ax
        invoke exit, 0
    .ENDIF

    mov     cx, 1
    .WHILE (retcode == 0)
        mov bx, cx
        shl bx, 1
        invoke Rockey, RY_FIND_NEXT, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        mov retcode, ax
        .BREAK .IF (ax == ERR_NOMORE)
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF

        invoke Rockey, RY_OPEN, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF

        inc cx
        puts   "Find Rock: "
        invoke print4h, lp1
        invoke printcr
    .ENDW
    invoke printcr

    mov     dx, cx
    xor     cx, cx
    .WHILE (cx < dx)
        mov bx, cx
        shl bx, 1

        mov p1, 4
        mov p2, 5
        invoke strcpy, ADDR buffer, ADDR info1
        invoke Rockey, RY_WRITE, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF
        putscr "Write: Hello"

        mov p1, 4
        mov p2, 5
        invoke memset, ADDR buffer, 0, 64
        invoke Rockey, RY_READ, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF
        puts "Read: "
        invoke prints, ADDR buffer
        invoke printcr

        invoke Rockey, RY_RANDOM, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF
        puts "Random: "
        invoke print2h, p1
        invoke printcr

        mov lp2, 12345678h
        invoke Rockey, RY_SEED, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF
        puts "Seed: "
        invoke print2h, p1
        invoke printc, 20h
        invoke print2h, p2
        invoke printc, 20h
        invoke print2h, p3
        invoke printc, 20h
        invoke print2h, p4
        invoke printcr
        invoke memcpy, ADDR rc, ADDR p1, 8

        mov lp1, 088888888h
        invoke Rockey, RY_WRITE_USERID, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF
        puts "Write User ID: "
        invoke print4h, lp1
        invoke printcr

        xor eax, eax
        mov lp1, eax
        invoke Rockey, RY_READ_USERID, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF
        puts "Read User ID: "
        invoke print4h, lp1
        invoke printcr

        mov p1, 7
        mov p2, 2121h
        mov p3, 0
        invoke Rockey, RY_SET_MOUDLE, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF
        puts "Set Moudle 7: Value = "
        invoke print2h, p2
        putscr " Decrease no allow"

        mov p1, 7
        invoke Rockey, RY_CHECK_MOUDLE, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF
        puts "Check Moudle 7: "
        mov ax, p2
        .IF (ax)
            puts "Allow   "
        .ELSE
            puts "No Allow   "
        .ENDIF
        mov ax, p3
        .IF (ax)
            puts "Allow Decrease"
        .ELSE
            puts "Not Allow Decrease"
        .ENDIF
        invoke printcr

        mov p1, 0
        invoke strcpy, ADDR buffer, ADDR cmd
        invoke Rockey, RY_WRITE_ARITHMETIC, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF
        putscr "Write Arithmetic 1"

        mov lp1, 0
        mov lp2, 7
        mov p1, 5
        mov p2, 3
        mov p3, 1
        mov p4, 0ffffh
        invoke Rockey, RY_CALCULATE1, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF
        putscr "Calculate Input: p1=5, p2=3, p3=1, p4=0xffff"
        putscr "Result = ((5*23 + 3*17 + 0x2121) < 1) ^ 0xffff = BC71"
        puts "Calculate Output: p1="
        invoke print2h, p1
        puts ", p2="
        invoke print2h, p2
        puts ", p3="
        invoke print2h, p3
        puts ", p4="
        invoke print2h, p4
        invoke printcr

        mov p1, 10
        invoke strcpy, ADDR buffer, ADDR cmd1
        invoke Rockey, RY_WRITE_ARITHMETIC, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF
        putscr "Write Arithmetic 2"

        mov lp1, 10
        mov lp2, 12345678h
        mov p1, 1
        mov p2, 2
        mov p3, 3
        mov p4, 4
        invoke Rockey, RY_CALCULATE2, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF
        putscr "Calculate Input: p1=1, p2=2, p3=3, p4=4"
        puts "Result = 1 + 2 + 3 + 4 + "
        xor di, di
        mov si, offset rc
        mov ax, [si]
        add di, ax
        invoke print2h, ax
        puts " + "
        add si, 2
        mov ax, [si]
        add di, ax
        invoke print2h, ax
        puts " + "
        add si, 2
        mov ax, [si]
        add di, ax
        invoke print2h, ax
        puts " + "
        add si, 2
        mov ax, [si]
        add di, ax
        invoke print2h, ax
        add di, 10
        puts " = "
        invoke print2h, di
        invoke printcr
        ; -----
        puts "Calculate Output: p1="
        invoke print2h, p1
        puts ", p2="
        invoke print2h, p2
        puts ", p3="
        invoke print2h, p3
        puts ", p4="
        invoke print2h, p4
        invoke printcr

        mov p1, 9
        mov p2, 5
        mov p3, 1
        invoke Rockey, RY_SET_MOUDLE, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF

        mov p1, 17
        invoke strcpy, ADDR buffer, ADDR cmd2
        invoke Rockey, RY_WRITE_ARITHMETIC, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF
        putscr "Write Arithmetic 3"

        mov lp1, 17
        mov lp2, 6
        mov p1, 1
        mov p2, 2
        mov p3, 3
        mov p4, 4
        invoke Rockey, RY_CALCULATE3, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF
        puts "Show Module from 6: p1="
        invoke print2h, p1
        puts ", p2="
        invoke print2h, p2
        puts ", p3="
        invoke print2h, p3
        puts ", p4="
        invoke print2h, p4
        invoke printcr

        mov p1, 9
        invoke Rockey, RY_DECREASE, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF
        putscr "Decrease module 9"

        mov lp1, 17
        mov lp2, 6
        mov p1, 1
        mov p2, 2
        mov p3, 3
        mov p4, 4
        invoke Rockey, RY_CALCULATE3, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF
        puts "Show Module from 6: p1="
        invoke print2h, p1
        puts ", p2="
        invoke print2h, p2
        puts ", p3="
        invoke print2h, p3
        puts ", p4="
        invoke print2h, p4
        invoke printcr

        invoke Rockey, RY_CLOSE, ADDR handle[bx], ADDR lp1, ADDR lp2, ADDR p1, ADDR p2, ADDR p3, ADDR p4, ADDR buffer
        .IF (ax != 0)
            invoke ShowERR, ax
            invoke exit, 0
        .ENDIF

        invoke printcr
        invoke getch
        inc cx

    .ENDW

    .EXIT 0

; =========================================================================

ShowERR  proc USES cx di, rcode:WORD

    puts "Error Code: "
    invoke  print2d, rcode
    invoke  printcr
    ret

ShowERR  endp

; =========================================================================

    END
