unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls,RyDef;

type
  TForm1 = class(TForm)
    BtnTest: TButton;
    MemoMsg: TMemo;
    procedure BtnTestClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure PrintStr(sMsg:String);
    procedure ReportErr(sAct:String;code:WORD);
    procedure TestRockey(hdl:Word);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
function  Rockey(fun:Word; var Handle:Word;
          var lp1,lp2:LongInt;var P1,P2,P3,P4:Word;
          var buf:Byte):Word;
          far;external 'rydll16';
var
   hdl:array [0..15] of Word;
   lp1,lp2:LongInt;
   p1,p2,p3,p4:Word;
   buffer:array [0..1024] of byte;
   retval:Word;
   nMaxCount:integer;

procedure TForm1.PrintStr(sMsg:String);
begin
     MemoMsg.Lines.Add(sMsg);
end;
procedure TForm1.ReportErr(sAct:String;code:WORD);
begin
     PrintStr(Format('%s Error [%x]',[sAct,code]));
end;

procedure TForm1.BtnTestClick(Sender: TObject);
var
   i:integer;
begin
     MemoMsg.Clear;

     p1 := $c44c;
     p2 := $c8f8;
     p3 := $0799;
     p4 := $c43b;

     retval := Rockey(RY_FIND,hdl[0],lp1,lp2,p1,p2,p3,p4,buffer[0]);
     if(retval <> ERR_SUCCESS) then
     begin
       ReportErr('Find ',retval);
       Exit;
     end;

    PrintStr(Format('Found Rockey HID[%x]',[lp1]));

    retval := Rockey(RY_OPEN,hdl[0],lp1,lp2,p1,p2,p3,p4,buffer[0]);
    if(retval <> ERR_SUCCESS) then
    begin
      ReportErr('Open ',retval);
      Exit;
    end;

    PrintStr(Format('Open Rockey [%x] Success',[lp1]));

    i := 1;

    while (retval = ERR_SUCCESS) do
    begin

      retval := Rockey(RY_FIND_NEXT,hdl[i],lp1,lp2,p1,p2,p3,p4,buffer[0]);
      if(retval = ERR_NOMORE) then
           break;
      if(retval <> ERR_SUCCESS) then
      begin
        ReportErr('Find ',retval);
        Exit;
      end;

      PrintStr(Format('Found ROCKEY HID[%x]',[lp1]));

      retval := Rockey(RY_OPEN,hdl[i],lp1,lp2,p1,p2,p3,p4,buffer[0]);
      if(retval <> ERR_SUCCESS) then
      begin
        ReportErr('Open ',retval);
        Exit;
      end;
      PrintStr(Format('Open Rockey [%x] Success',[lp1]));
      Inc(i);
    end;
    nMaxCount := i;
    PrintStr(Format('%d ROCKEY Found ',[nMaxCount]));

    for i:=0 to nMaxCount-1 do
    begin
         TestRockey(hdl[i]);
    end;

    for i:=0 to nMaxCount-1 do
    begin
      retval := Rockey(RY_CLOSE,hdl[i],lp1,lp2,p1,p2,p3,p4,buffer[0]);
      if(retval <> ERR_SUCCESS) then
      begin
        ReportErr('Close ',retval);
        Exit;
      end;
    end;

    PrintStr('Close All Rockey');
end;

procedure TForm1.TestRockey(hdl:Word);
var
   j,l:integer;
   strBuf,strBufE:String;
   rc: array [0..3] of word;
begin
     PrintStr('');
     PrintStr(Format('Test  ROCKEY %d ',[hdl]));

     l := 12;
     StrCopy(PChar(@buffer),'Hello ROCKEY');
     p1 := 0;
     p2 := l;
     retval := Rockey(RY_WRITE,hdl,lp1,lp2,p1,p2,p3,p4,buffer[0]);
      if(retval <> ERR_SUCCESS) then
      begin
        ReportErr('Write ',retval);
        Exit;
      end;

     PrintStr('Write  [Hello ROCKEY] success');

     p1 := 0;
     p2 := l-1;

     retval := Rockey(RY_READ,hdl,lp1,lp2,p1,p2,p3,p4,buffer[0]);
     if(retval <> ERR_SUCCESS) then
     begin
       ReportErr('Read ',retval);
       Exit;
     end;
     strBuf := '';
     for j:=0 to l-2 do
       strBuf := strBuf + chr(buffer[j]);

     PrintStr(Format('Read  [%s] success',[strBuf]));

     retval := Rockey(RY_RANDOM,hdl,lp1,lp2,p1,p2,p3,p4,buffer[0]);
     if(retval <> ERR_SUCCESS) then
     begin
       ReportErr('Random ',retval);
       Exit;
     end;
     PrintStr(Format('Random value [%x] ',[p1]));

     lp1 := $12345678;
     retval := Rockey(RY_SEED,hdl,lp1,lp2,p1,p2,p3,p4,buffer[0]);
     if(retval <> ERR_SUCCESS) then
     begin
       ReportErr('Seed ',retval);
       Exit;
     end;
     PrintStr(Format('seed return code [%x %x %x %x] ',[p1,p2,p3,p4]));
     rc[0] := p1;
     rc[1] := p2;
     rc[2] := p3;
     rc[3] := p4;

     lp1 := $88888888;
     retval := Rockey(RY_WRITE_USERID,hdl,lp1,lp2,p1,p2,p3,p4,buffer[0]);
     if(retval <> ERR_SUCCESS) then
     begin
       ReportErr('Write USERID 88888888 ' , retval);
       Exit;
     end;
     PrintStr('Write USERID success');

     lp1 := 0;
     retval := Rockey(RY_READ_USERID,hdl,lp1,lp2,p1,p2,p3,p4,buffer[0]);
     if(retval <> ERR_SUCCESS) then
     begin
       ReportErr('Read USERID' , retval);
       Exit;
     end;
     PrintStr(Format('Read USERID [%x] ',[lp1]));

     p1:=7;
     p2:=$2121;
     p3:=1;
     retval := Rockey(RY_SET_MOUDLE,hdl,lp1,lp2,p1,p2,p3,p4,buffer[0]);
     if(retval <> ERR_SUCCESS) then
     begin
       ReportErr('Set module ' , retval);
       Exit;
     end;
     PrintStr('Set module success');

     p1:=7;
     retval := Rockey(RY_CHECK_MOUDLE,hdl,lp1,lp2,p1,p2,p3,p4,buffer[0]);
     if(retval <> ERR_SUCCESS) then
     begin
       ReportErr('check module ' , retval);
       Exit;
     end;
     strBuf := 'invalidate ';
     strBufE := 'dec unable ';
     if(p2 = 1) then
           strBuf := 'validate';
     if(p3 = 1) then
           strBufE := 'dec able ';

     PrintStr(Format('Check module 7 %s %s ',[strBuf,strBufE]));

     StrCopy(PChar(@buffer),'H=H^H, A=A*23, F=B*17, A=A+F, A=A+G, A=A<C, A=A^D, B=B^B, C=C^C, D=D^D');

     p1 := 0;
     retval := Rockey(RY_WRITE_ARITHMETIC,hdl,lp1,lp2,p1,p2,p3,p4,buffer[0]);
     if(retval <> ERR_SUCCESS) then
     begin
       ReportErr('Write CALCULATE1 ' , retval);
       Exit;
     end;
     PrintStr('CALCULATE1');

    lp1 := 0;
    lp2 := 7;
    p1 := 5;
    p2 := 3;
    p3 := 1;
    p4 := $ffff;

    retval := Rockey(RY_CALCULATE1,hdl,lp1,lp2,p1,p2,p3,p4,buffer[0]);
     if(retval <> ERR_SUCCESS) then
     begin
       ReportErr('run CALCULATE1 ' , retval);
       Exit;
     end;
     PrintStr('input p1=5, p2=3, p3=1, p4=0xffff');
     PrintStr('Result = ((5*23 + 3*17 + 0x2121) < 1) ^ 0xffff = BC71');
     PrintStr(Format('output p1=%x, p2=%x, p3=%x, p4=%x',[p1,p2,p3,p4]));


     StrCopy(PChar(@buffer),'A=A+B, A=A+C, A=A+D, A=A+E, A=A+F, A=A+G, A=A+H');

     p1 := 10;
     retval := Rockey(RY_WRITE_ARITHMETIC,hdl,lp1,lp2,p1,p2,p3,p4,buffer[0]);
     if(retval <> ERR_SUCCESS) then
     begin
       ReportErr('Write CALCULATE2 ' , retval);
       Exit;
     end;
     PrintStr('CALCULATE2');

    lp1 := 10;
    lp2 := $12345678;
    p1 := 1;
    p2 := 2;
    p3 := 3;
    p4 := 4;

    retval := Rockey(RY_CALCULATE2,hdl,lp1,lp2,p1,p2,p3,p4,buffer[0]);
    if(retval <> ERR_SUCCESS) then
    begin
       ReportErr('run CALCULATE2 ' , retval);
       Exit;
    end;
    PrintStr('input p1=1, p2=2, p3=3, p4=4');
    PrintStr(Format('Result =  %04x + %04x + %04x + %04x + 1 + 2 + 3 + 4 = %04x',
    [rc[0], rc[1], rc[2], rc[3], Word(rc[0]+rc[1]+rc[2]+rc[3]+10)]));
    PrintStr(Format('output p1=%x, p2=%x, p3=%x, p4=%x',[p1,p2,p3,p4]));


     StrCopy(PChar(@buffer),'A=E|E, B=F|F, C=G|G, D=H|H');

     p1 := 17;
     retval := Rockey(RY_WRITE_ARITHMETIC,hdl,lp1,lp2,p1,p2,p3,p4,buffer[0]);
     if(retval <> ERR_SUCCESS) then
     begin
       ReportErr('Write CALCULATE3 ' , retval);
       Exit;
     end;
     PrintStr('CALCULATE3');

    lp1 := 17;
    lp2 := 6;
    p1 := 1;
    p2 := 2;
    p3 := 3;
    p4 := 4;

    retval := Rockey(RY_CALCULATE3,hdl,lp1,lp2,p1,p2,p3,p4,buffer[0]);
    if(retval <> ERR_SUCCESS) then
    begin
       ReportErr('run CALCULATE3 ' , retval);
       Exit;
    end;
    PrintStr(Format('mod 6 --9  %x %x %x %x',[p1,p2,p3,p4]));

    p1 := 7;
    retval := Rockey(RY_DECREASE,hdl,lp1,lp2,p1,p2,p3,p4,buffer[0]);
    if(retval <> ERR_SUCCESS) then
    begin
       ReportErr('run DECREASE ' , retval);
       Exit;
    end;

    lp1 := 17;
    lp2 := 6;
    p1 := 1;
    p2 := 2;
    p3 := 3;
    p4 := 4;

    retval := Rockey(RY_CALCULATE3,hdl,lp1,lp2,p1,p2,p3,p4,buffer[0]);
    if(retval <> ERR_SUCCESS) then
    begin
       ReportErr('run CALCULATE3 ' , retval);
       Exit;
    end;
    PrintStr(Format('mod 6 --9  %x %x %x %x',[p1,p2,p3,p4]));

end;

end.

